﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(BoxCollider2D))]

public class CloakedFigure : MonoBehaviour {

	private Vector3 _ScreenPoint;
	private Vector3 _Offset;
	private Vector3 _Target;

	public  bool _Employed;

	Sprite _CloakFront;
	Sprite _CloakBack;
	Sprite _CloakLeft1;
	Sprite _CloakLeft2;
	Sprite _CloakRight1;
	Sprite _CloakRight2;

	// Use this for initialization
	void Start () {
		_Target = transform.position;
		_Employed = false;

		_CloakFront = Resources.Load<Sprite>("Cloak/cloak_front");
		_CloakBack = Resources.Load<Sprite>("Cloak/cloak_back");
		_CloakLeft1 = Resources.Load<Sprite>("Cloak/cloak_left1");
		_CloakLeft2 = Resources.Load<Sprite>("Cloak/cloak_left2");
		_CloakRight1 = Resources.Load<Sprite>("Cloak/cloak_right1");
		_CloakRight2 = Resources.Load<Sprite>("Cloak/cloak_right2");
	}
	
	// Update is called once per frame
	void Update () {
		//if (Input.GetMouseButton(0))

		Rigidbody2D r = GetComponent<Rigidbody2D>();
		if (r.IsSleeping())
			r.WakeUp();
		
		transform.position += 0.1f*(_Target-transform.position);

		var angles = transform.Find("shadow").rotation.eulerAngles;
		angles = Vector3.forward * (90+(360.0f/(2*Mathf.PI))*Mathf.Atan2(transform.position.y,transform.position.x));

		var t = Vector3.Magnitude(new Vector3(transform.position.x, transform.position.y, 0.001f));

		transform.Find("shadow").rotation = Quaternion.Euler(angles);
		transform.Find("shadow").localScale = new Vector3(1.0f,2.0f/t,1.0f);

		var pos = transform.position;
		pos.z = -1.0f + pos.y * 0.1f;
		transform.position = pos;

		SpriteRenderer render = transform.Find("sprite").GetComponent<SpriteRenderer>();

		Vector3 facing = transform.position - _Target;
		Debug.Log(facing.sqrMagnitude);
		if (facing.sqrMagnitude < 0.02f)
		{
			facing = transform.position;
		}
		float angle = Mathf.Atan2(facing.y,facing.x);

		angle = 360.0f*angle/(2*Mathf.PI) % 360.0f;
		while (angle < 0.0f)   angle += 360.0f;
		while (angle > 360.0f) angle -= 360.0f;

		if (0 <= angle && angle < 60)
		{
			render.sprite = _CloakRight1;
		}
		else if (60 <= angle && angle < 120)
		{
			render.sprite = _CloakFront;
		}
		else if (120 <= angle && angle < 180)
		{
			render.sprite = _CloakLeft1;
		}
		else if (180 <= angle && angle < 240)
		{
			render.sprite = _CloakLeft2;
		}
		else if (240 <= angle && angle < 300)
		{
			render.sprite = _CloakBack;
		}
		else if (300 <= angle && angle < 360)
		{
			render.sprite = _CloakRight2;
		}
	}

	void OnMouseDown() {
		_Offset = gameObject.transform.position - Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, _ScreenPoint.z));
	}

	void OnMouseDrag()
	{
		Vector3 curScreenPoint = new Vector3(Input.mousePosition.x, Input.mousePosition.y, _ScreenPoint.z);
		Vector3 curPosition = Camera.main.ScreenToWorldPoint(curScreenPoint) + _Offset;
		//transform.position = curPosition;
		_Target = curPosition;
	}

	void OnTriggerEnter2D (Collider2D other)
	{
		_Employed = true;
	}
	void OnTriggerExit2D (Collider2D other)
	{
		_Employed = false;
	}

}