﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Column : MonoBehaviour {

	public enum ColumnType { Up, Down, Central, Divide, Booze, Dagger, Cloak };
	public ColumnType Type;
	private GlobalVariables global;
	public Help.HelpType ThisHelp;

	// Use this for initialization
	void Start () {
		global = (GlobalVariables)FindObjectOfType(typeof(GlobalVariables));
		//Collider = GetComponent<CircleCollider2D>();
	}
	
	// Update is called once per frame
	void Update () {
		//Debug.Log(Collider.OverlapCollider());
	}

	void OnMouseEnter()
	{
		if (Input.GetMouseButton(0)) return;
		Help help = (Help)FindObjectOfType(typeof(Help));
		help.ShowHelp(ThisHelp);
	}

	void OnMouseExit()
	{
		Help help = (Help)FindObjectOfType(typeof(Help));
		help.Stop();
	}

	void OnCollisionEnter2D(Collision2D other) {
		
	}
	void OnTriggerStay2D (Collider2D other) {

		float dt = Time.fixedDeltaTime * 0.3f;

		// I could do this properly with different classes that do different things...
		// or I could just use a massive switch-statement.

		if (Type == ColumnType.Up) {
			global._Doom += 0.08f*dt;
			global._Fear += 0.03f*dt;
		}
		else if (Type == ColumnType.Down) {
			global._Doom -= 0.05f*dt;
			global._Fear += 0.02f*dt;
		}
		else if (Type == ColumnType.Central) {
			global._Fear += 0.07f*dt;
			global._Booze -= 0.03f*dt;
			global._Daggers -= 0.02f*dt;
		}
		else if (Type == ColumnType.Divide) {
			global._Fear -= 0.07f*dt;
			global._Booze -= 0.05f*dt;
			global._Daggers -= 0.02f*dt;
		}
		else if (Type == ColumnType.Booze) {
			global._Booze += 0.11f*dt;
			global._Cloaks -= 0.02f*dt;
		}
		else if (Type == ColumnType.Dagger) {
			global._Daggers += 0.07f*dt;
			global._Doom += 0.02f*dt;
			global._Fear += 0.02f*dt;
			global._Cloaks -= 0.05f*dt;
		}
		else if (Type == ColumnType.Cloak) {
			global._Doom   -= 0.02f*dt;
			global._Cloaks += 0.07f*dt;
			global._Daggers -= 0.05f*dt;
		}
	}
}
