﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class GlobalVariables : MonoBehaviour {

	public float _Doom;
	public float _Fear;
	public float _Booze;
	public float _Daggers;
	public float _Cloaks;

	public GameObject _DoomCircle;
	public GameObject _FearCircle;
	public GameObject _BoozeCircle;
	public GameObject _DaggersCircle;
	public GameObject _CloaksCircle;

	private LineRenderer_Circle _DoomCircleLine;
	private LineRenderer_Circle _FearCircleLine;
	private LineRenderer_Circle _BoozeCircleLine;
	private LineRenderer_Circle _DaggersCircleLine;
	private LineRenderer_Circle _CloaksCircleLine;

	public bool ShouldUpdate;

	// Use this for initialization
	void Start () {

		_Doom = 0.0f;
		_Fear = 0.4f;
		_Booze = 0.4f;
		_Daggers = 0.4f;
		_Cloaks = 0.4f;

		_DoomCircleLine =    _DoomCircle.GetComponent<LineRenderer_Circle>();
		_FearCircleLine =    _FearCircle.GetComponent<LineRenderer_Circle>();
		_BoozeCircleLine =   _BoozeCircle.GetComponent<LineRenderer_Circle>();
		_DaggersCircleLine = _DaggersCircle.GetComponent<LineRenderer_Circle>();
		_CloaksCircleLine =  _CloaksCircle.GetComponent<LineRenderer_Circle>();

		_DoomCircleLine.UpdateNumber(_Doom);
		_FearCircleLine.UpdateNumber(_Fear);
		_BoozeCircleLine.UpdateNumber(_Booze);
		_DaggersCircleLine.UpdateNumber(_Daggers);
		_CloaksCircleLine.UpdateNumber(_Cloaks);
	}
	
	// Update is called once per frame
	void Update () {

		if (Input.GetKeyDown("space"))
		{
			SceneManager.LoadScene("Scene1", LoadSceneMode.Single);
		}

		_DoomCircleLine.UpdateNumber(_Doom);
		_FearCircleLine.UpdateNumber(_Fear);
		_BoozeCircleLine.UpdateNumber(_Booze);
		_DaggersCircleLine.UpdateNumber(_Daggers);
		_CloaksCircleLine.UpdateNumber(_Cloaks);

		if (ShouldUpdate == false)
			return;

		int UnemployedCount = 0;
		CloakedFigure[] CloakedFigures = (CloakedFigure[])FindObjectsOfType(typeof(CloakedFigure));
		int FigureCount = CloakedFigures.Length;
		foreach (CloakedFigure Figure in CloakedFigures)
		{
			if (Figure._Employed == false)
			{
				UnemployedCount++;
			}
		}

		float dt = Time.deltaTime;
		_Doom += 0.02f*Mathf.Sqrt(UnemployedCount)*dt;

		//_Cloaks += (0.02f+0.04f*_Doom)*dt;

		float SpawnNewCloakProb = _Cloaks * (Mathf.Sqrt(FigureCount+1) / 2);

		if (9000*dt*Random.value < SpawnNewCloakProb) {
			GameObject instance = Instantiate(
				Resources.Load("Prefabs/CloakedFigure", typeof(GameObject)),
				Quaternion.Euler(0,0,360.0f*Random.value) * new Vector3(0.5f+Random.value,0.0f,0.0f),
				Quaternion.identity
			) as GameObject;
			//Instantiate(Resources.Load("Prefabs/CloakedFigure", typeof(GameObject)),Vector3(1.5f,0.0f,0.0f) * Quaternion.Euler(0,0,360.0f*Random.value));
		}

		if (_Doom < 0.0f) _DoomCircleLine.BigRedX(false);
		if (_Fear < 0.0f) _FearCircleLine.BigRedX(false);
		if (_Booze < 0.0f) _BoozeCircleLine.BigRedX(false);
		if (_Daggers < 0.0f) _DaggersCircleLine.BigRedX(false);
		if (_Cloaks < 0.0f) _CloaksCircleLine.BigRedX(false);

		if (_Doom > 1.0f) _DoomCircleLine.BigRedX(true);
		if (_Fear > 1.0f) _FearCircleLine.BigRedX(true);
		if (_Booze > 1.0f) _BoozeCircleLine.BigRedX(true);
		if (_Daggers > 1.0f) _DaggersCircleLine.BigRedX(true);
		if (_Cloaks > 1.0f) _CloaksCircleLine.BigRedX(true);

		_DoomCircleLine.UpdateNumber(_Doom);
		_FearCircleLine.UpdateNumber(_Fear);
		_BoozeCircleLine.UpdateNumber(_Booze);
		_DaggersCircleLine.UpdateNumber(_Daggers);
		_CloaksCircleLine.UpdateNumber(_Cloaks);
	}
}
