﻿using System.Collections;
using System.Collections.Generic;

using UnityEngine;
using UnityEngine.SceneManagement;

public class Help : MonoBehaviour {

	Sprite sStartHelp;

	Sprite sGameOverHiA;
	Sprite sGameOverHiB;
	Sprite sGameOverHiC;
	Sprite sGameOverHiD;
	Sprite sGameOverHiF;
	Sprite sGameOverLoA;
	Sprite sGameOverLoB;
	Sprite sGameOverLoC;
	Sprite sGameOverLoD;
	Sprite sGameOverLoF;

	Sprite sHelp1;
	Sprite sHelp2;
	Sprite sHelp3;
	Sprite sHelp4;
	Sprite sHelp5;

	Sprite sHelpA;
	Sprite sHelpB;
	Sprite sHelpC;
	Sprite sHelpD;
	Sprite sHelpE;
	Sprite sHelpF;
	Sprite sHelpG;

	public enum HelpType {
	GameOverHiA, 
	GameOverHiB,
	GameOverHiC,
	GameOverHiD,
	GameOverHiF,
	GameOverLoA,
	GameOverLoB,
	GameOverLoC,
	GameOverLoD,
	GameOverLoF,
	Help1,
	Help2,
	Help3,
	Help4,
	Help5,
	HelpA,
	HelpB,
	HelpC,
	HelpD,
	HelpE,
	HelpF,
	HelpG
	};

	bool Locked;
	public bool StartHelp;

	public void ShowHelp(HelpType type, bool shouldLock=false) {

		if (Locked) return;

		SpriteRenderer render = GetComponent<SpriteRenderer>();
		render.enabled = true;

		if (type == HelpType.GameOverHiA) {
			render.sprite = sGameOverHiA;
		}
		else if (type == HelpType.GameOverHiB) {
			render.sprite = sGameOverHiB;
		}
		else if (type == HelpType.GameOverHiC) {
			render.sprite = sGameOverHiC;
		}
		else if (type == HelpType.GameOverHiD) {
			render.sprite = sGameOverHiD;
		}
		else if (type == HelpType.GameOverHiF) {
			render.sprite = sGameOverHiF;
		}
		else if (type == HelpType.GameOverLoA) {
			render.sprite = sGameOverLoA;
		}
		else if (type == HelpType.GameOverLoB) {
			render.sprite = sGameOverLoB;
		}
		else if (type == HelpType.GameOverLoC) {
			render.sprite = sGameOverLoC;
		}
		else if (type == HelpType.GameOverLoD) {
			render.sprite = sGameOverLoD;
		}
		else if (type == HelpType.GameOverLoF) {
			render.sprite = sGameOverLoF;
		}

		else if (type == HelpType.Help1) {
			render.sprite = sHelp1;
		}
		else if (type == HelpType.Help2) {
			render.sprite = sHelp2;
		}
		else if (type == HelpType.Help3) {
			render.sprite = sHelp3;
		}
		else if (type == HelpType.Help4) {
			render.sprite = sHelp4;
		}
		else if (type == HelpType.Help5) {
			render.sprite = sHelp5;
		}
		else if (type == HelpType.HelpA) {
			render.sprite = sHelpA;
		}
		else if (type == HelpType.HelpB) {
			render.sprite = sHelpB;
		}
		else if (type == HelpType.HelpC) {
			render.sprite = sHelpC;
		}
		else if (type == HelpType.HelpD) {
			render.sprite = sHelpD;
		}
		else if (type == HelpType.HelpE) {
			render.sprite = sHelpE;
		}
		else if (type == HelpType.HelpF) {
			render.sprite = sHelpF;
		}
		else if (type == HelpType.HelpG) {
			render.sprite = sHelpG;
		}

		if (shouldLock)
		{
			Locked = true;
			Clock c = (Clock)FindObjectOfType(typeof(Clock));
			c.bStop = true;
		}
	}

	public void Stop() {
		SpriteRenderer render = GetComponent<SpriteRenderer>();

		if (StartHelp) {
			Debug.Log("Beep");
			render.enabled = true;
			render.sprite = sStartHelp;
			return;
		}

		if (Locked) return;
		render.enabled = false;
	}

	// Use this for initialization
	void Start () {

		sStartHelp = Resources.Load<Sprite>("Helps/BeginHelp");

		sGameOverHiA = Resources.Load<Sprite>("Helps/GameOverHiA");
		sGameOverHiB = Resources.Load<Sprite>("Helps/GameOverHiB");
		sGameOverHiC = Resources.Load<Sprite>("Helps/GameOverHiC");
		sGameOverHiD = Resources.Load<Sprite>("Helps/GameOverHiD");
		sGameOverHiF = Resources.Load<Sprite>("Helps/GameOverHiF");

		sGameOverLoA = Resources.Load<Sprite>("Helps/GameOverLoA");
		sGameOverLoB = Resources.Load<Sprite>("Helps/GameOverLoB");
		sGameOverLoC = Resources.Load<Sprite>("Helps/GameOverLoC");
		sGameOverLoD = Resources.Load<Sprite>("Helps/GameOverLoD");
		sGameOverLoF = Resources.Load<Sprite>("Helps/GameOverLoF");

		sHelp1 = Resources.Load<Sprite>("Helps/help1");
		sHelp2 = Resources.Load<Sprite>("Helps/help2");
		sHelp3 = Resources.Load<Sprite>("Helps/help3");
		sHelp4 = Resources.Load<Sprite>("Helps/help4");
		sHelp5 = Resources.Load<Sprite>("Helps/help5");
		sHelpA = Resources.Load<Sprite>("Helps/helpA");
		sHelpB = Resources.Load<Sprite>("Helps/helpB");
		sHelpC = Resources.Load<Sprite>("Helps/helpC");
		sHelpD = Resources.Load<Sprite>("Helps/helpD");
		sHelpE = Resources.Load<Sprite>("Helps/helpE");
		sHelpF = Resources.Load<Sprite>("Helps/helpF");
		sHelpG = Resources.Load<Sprite>("Helps/helpG");

		Stop();
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetMouseButtonDown(0) && StartHelp)
		{
			StartHelp = false;
			SceneManager.LoadScene("Scene1", LoadSceneMode.Single);
		}
	}
}
