﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(LineRenderer))]

public class LineRenderer_Circle : MonoBehaviour
{
	public int segments;
	public float xradius;
	public float yradius;
	LineRenderer line;

	public Help.HelpType ThisHelp;
	public Help.HelpType TooHigh;
	public Help.HelpType TooLow;

	public float _Proportion;
	private bool _HasBigRedX;

	void Start ()
	{
		_Proportion = 0.0f;
		_HasBigRedX = false;

		line = gameObject.GetComponent<LineRenderer>();
		line.SetVertexCount (segments + 2);
		line.useWorldSpace = false;
		CreatePoints ();
	}

	void Update ()
	{
		//_Proportion += 0.005f;
		//CreatePoints ();
	}

	public void UpdateNumber (float NewNumber)
	{
		_Proportion = NewNumber;
		CreatePoints ();
	}

	void CreatePoints ()
	{
		float x;
		float y;
		float z = 0f;

		float angle = 0.0f;

		line.SetPosition (0,new Vector3(0,0,0) );
		for (int i = 1; i < (segments + 2); i++)
		{
			x = Mathf.Sin (Mathf.Deg2Rad * angle) * xradius;
			y = Mathf.Cos (Mathf.Deg2Rad * angle) * yradius;

			line.SetPosition (i,new Vector3(x,y,z) );

			angle += (360f / segments);

			if (i > segments*_Proportion) {
				line.SetPosition (i,new Vector3(0,0,0) );
			}
		}
	}

	public void BigRedX(bool IsTooHigh)
	{
		if (_HasBigRedX) return;
		GameObject BigRedX = Instantiate(Resources.Load("Prefabs/BigRedX", typeof(GameObject)),Vector3.zero,Quaternion.identity) as GameObject;
		BigRedX.transform.parent = gameObject.transform;
		BigRedX.transform.localPosition = Vector3.zero;
		_HasBigRedX = true;

		Help help = (Help)FindObjectOfType(typeof(Help));
		if (IsTooHigh) help.ShowHelp(TooHigh, true);
		else help.ShowHelp(TooLow, true);
	}

	void OnMouseEnter()
	{
		Help help = (Help)FindObjectOfType(typeof(Help));
		help.ShowHelp(ThisHelp);
	}

	void OnMouseExit()
	{
		Help help = (Help)FindObjectOfType(typeof(Help));
		help.Stop();
	}
}